﻿using Redmine.Net.Api;
using Redmine.Net.Api.Async;
using Redmine.Net.Api.Types;
using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace RedmineOracle
{


    public class ListIstIssues
    {
        public struct JournaleNotes
        {
            public int idNote { get; set; }
            public string NoteAuthor { get; set; }
            public string NoteDescription { get; set; }
            public DateTime CreatedOn { get; set; }
        }
        public struct Issues
        {
            public int Id { get; set; }
            public string Name { get; set; }
            public string Description { get; set; }
            public string NoteAuthor { get; set; }
            public string Status { get; set; }
            public string Project { get; set; }
            public string Journal { get; set; }
            public string IssueAuthor { get; set; }
            public string idLRP { get; set; }
            public string Responsible { get; set; }
            public DateTime CreatedOn { get; set; }
            public DateTime DateComplite { get; set; }
            public DateTime DateLastComment { get; set; }
            public DateTime LastUpdate { get; set; }
            public string VisibilityDateLastComment { get; set; }
        }

        public struct Userss
        {
            public int Id { get; set; }
            public string UserName { get; set; }

        }


        public ListIstIssues()
        {

        }


        public void UploadAttachment(int idIssue, string path)
        {
            var host = "http://testred.ru/";
            var parameters = new NameValueCollection();
            RedmineManager a = new RedmineManager(host, infoAuth.loginRm, infoAuth.passwordRm);
           
            FileStream fs = new FileStream(path, FileMode.Open, FileAccess.Read);

           
            byte[] ImageData = new byte[fs.Length];

            
            fs.Read(ImageData, 0, System.Convert.ToInt32(fs.Length));

           
            fs.Close();
            byte[] documentData = ImageData;

            
            Upload attachment = a.UploadFile(documentData);

           
            attachment.FileName = Path.GetFileName(path);
            attachment.Description = "";
            attachment.ContentType = Path.GetExtension(path);

            
            IList<Upload> attachments = new List<Upload>();
            attachments.Add(attachment);
            parameters.Add("issue_id", idIssue.ToString());
            parameters.Add("include", "journals");
            Issue issues = a.GetObject<Issue>(idIssue.ToString(), parameters);
            issues.Uploads = attachments;
            a.UpdateObject(issues.Id.ToString(), issues);
            

        }

        public List<Userss> allUsers()
        {
            List<Userss> users = new List<Userss>();

            var host = "http://testred.ru/";
            var parameters = new NameValueCollection();
            RedmineManager a = new RedmineManager(host, infoAuth.loginRm, infoAuth.passwordRm);
            IList<User> us = a.GetObjects<User>();
            foreach (User user in us)
            {
                Userss u = new Userss();
                u.Id = user.Id;
                u.UserName = user.Login;
                users.Add(u);
            }
            return users;
        }

        public List<Issues> getRespondIss(int id)
        {
            List<Issues> Issuess = new List<Issues>();
            var host = "http://testred.ru/";
            var parameters = new NameValueCollection();
            parameters.Add("include", "journals");
            parameters.Add("project_id", "5");
            parameters.Add("status_id", "1|2|4");
            parameters.Add(RedmineKeys.ASSIGNED_TO_ID, id.ToString());
            RedmineManager a = new RedmineManager(host, infoAuth.loginRm, infoAuth.passwordRm);
            IList<Issue> issues = a.GetObjects<Issue>(parameters);
            if (issues != null)
                foreach (var issue in issues)
                {
                    Issues issue2 = new Issues();
                    issue2.Id = issue.Id;
                    issue2.Name = issue.Subject;
                    issue2.Description = issue.Description;
                    issue2.IssueAuthor = issue.Author.Name;
                    issue2.Project = issue.Project.Name;
                    issue2.DateComplite = Convert.ToDateTime(issue.DueDate);
                    issue2.Status = issue.Status.Name;
                    issue2.LastUpdate = Convert.ToDateTime(issue.UpdatedOn);
                    if (issue.AssignedTo.Name != null)
                        issue2.Responsible = issue.AssignedTo.Name;
                    issue2.CreatedOn = Convert.ToDateTime(issue.CreatedOn);
                    foreach (var cf in issue.CustomFields)
                    {
                        if (cf.Values != null)
                            issue2.idLRP = cf.Values[0].Info;
                    }
                    issue2.VisibilityDateLastComment = "Collapsed";
                    IList<Journal> issuesjournal = a.GetObject<Issue>(issue.Id.ToString(), parameters).Journals;
                    if (issuesjournal != null)
                        foreach (var journal in issuesjournal)
                        {
                            if (journal.Notes != null)
                            {
                                issue2.Journal = journal.Notes;
                                issue2.DateLastComment = Convert.ToDateTime(journal.CreatedOn);
                                issue2.VisibilityDateLastComment = "Visible";
                            }

                        }
                    Issuess.Add(issue2);

                }
            Issuess = Issuess.OrderBy(x => x.LastUpdate).ToList();
            Issuess.Reverse();
            return Issuess;
        }

        public List<Issues> createList()
        {
            List<Issues> Issuess = new List<Issues>();
            var host = "http://testred.ru/";
            var parameters = new NameValueCollection();
            parameters.Add("include", "journals");
            parameters.Add("project_id", "5");
            parameters.Add("status_id", "1|2|4");
            RedmineManager a = new RedmineManager(host, infoAuth.loginRm, infoAuth.passwordRm);
            IList<Issue> issues = a.GetObjects<Issue>(parameters);
            foreach (var issue in issues)
            {
                Issues issue2 = new Issues();
                issue2.Id = issue.Id;
                issue2.Name = issue.Subject;
                issue2.Description = issue.Description;
                issue2.IssueAuthor = issue.Author.Name;
                issue2.Project = issue.Project.Name;
                issue2.DateComplite = Convert.ToDateTime(issue.DueDate);
                issue2.Status = issue.Status.Name;
                issue2.LastUpdate = Convert.ToDateTime(issue.UpdatedOn);
                if (issue.AssignedTo.Name != null)
                    issue2.Responsible = issue.AssignedTo.Name;
                issue2.CreatedOn = Convert.ToDateTime(issue.CreatedOn);
                foreach (var cf in issue.CustomFields)
                {
                    if (cf.Values != null)
                        issue2.idLRP = cf.Values[0].Info;
                }
                issue2.VisibilityDateLastComment = "Collapsed";
                IList<Journal> issuesjournal = a.GetObject<Issue>(issue.Id.ToString(), parameters).Journals;
                if (issuesjournal != null)
                    foreach (var journal in issuesjournal)
                    {
                        if (journal.Notes != null)
                        {
                            issue2.Journal = journal.Notes;
                            issue2.DateLastComment = Convert.ToDateTime(journal.CreatedOn);
                            issue2.VisibilityDateLastComment = "Visible";
                        }

                    }
                Issuess.Add(issue2);

            }
            Issuess = Issuess.OrderBy(x => x.LastUpdate).ToList();
            Issuess.Reverse();
            return Issuess;
        }

        public Issues currIss(int id)
        {
            var host = "http://testred.ru/";
            var parameters = new NameValueCollection();
            parameters.Add("issue_id", id.ToString());
            parameters.Add("include", "journals");
            Issues issue2 = new Issues();
            RedmineManager a = new RedmineManager(host, infoAuth.loginRm, infoAuth.passwordRm);
            IList<Issue> issues = a.GetObjects<Issue>(parameters);
            foreach (var issue in issues)
            {
                issue2.Id = issue.Id;
                issue2.Name = issue.Subject;
                issue2.Description = issue.Description;
                issue2.IssueAuthor = issue.Author.Name;
                issue2.Project = issue.Project.Name;
                issue2.DateComplite = Convert.ToDateTime(issue.DueDate);
                issue2.Status = issue.Status.Name;
                issue2.LastUpdate = Convert.ToDateTime(issue.UpdatedOn);
                if (issue.AssignedTo.Name != null)
                    issue2.Responsible = issue.AssignedTo.Name;
                issue2.CreatedOn = Convert.ToDateTime(issue.CreatedOn);
                foreach (var cf in issue.CustomFields)
                {
                    if (cf.Values != null)
                        issue2.idLRP = cf.Values[0].Info;
                }
                issue2.VisibilityDateLastComment = "Collapsed";
                IList<Journal> issuesjournal = a.GetObject<Issue>(issue.Id.ToString(), parameters).Journals;
                if (issuesjournal != null)
                    foreach (var journal in issuesjournal)
                    {
                        if (journal.Notes != null)
                        {
                            issue2.Journal = journal.Notes;
                            issue2.DateLastComment = Convert.ToDateTime(journal.CreatedOn);
                            issue2.VisibilityDateLastComment = "Visible";
                        }

                    }

            }
            return issue2;
        }
        public List<JournaleNotes> listNotes(int id)
        {
            RedmineManager a;
            var host = "http://testred.ru/";
            a = new RedmineManager(host, infoAuth.loginRm, infoAuth.passwordRm);
            User currentUser = a.GetCurrentUser();
            var parameters = new NameValueCollection();
            parameters.Add("issue_id", id.ToString());
            parameters.Add("include", "journals");
            IList<Issue> issues = a.GetObjects<Issue>(parameters);
            List<JournaleNotes> listJournal = new List<JournaleNotes>();
            foreach (var issue in issues)
            {
                IList<Journal> issuesjournal = a.GetObject<Issue>(id.ToString(), parameters).Journals;

                if (issuesjournal != null)
                    foreach (var journal in issuesjournal)
                    {
                        JournaleNotes jn = new JournaleNotes();
                        if (journal.Notes != "")
                        {
                            jn.idNote = journal.Id;
                            jn.NoteAuthor = journal.User.Name;
                            jn.NoteDescription = journal.Notes;
                            jn.CreatedOn = Convert.ToDateTime(journal.CreatedOn);
                            listJournal.Add(jn);
                        }
                    }
            }
            return listJournal;
        }

        public void AddNewComm(int id, string comm)
        {
            var host = "http://testred.ru/";
            var a = new RedmineManager(host, infoAuth.loginRm, infoAuth.passwordRm);
            var parameters = new NameValueCollection();
            User currentUser = a.GetCurrentUser();
            parameters.Add("issue_id", id.ToString());
            parameters.Add("include", "journals");
            Issue issues = a.GetObject<Issue>(id.ToString(), parameters);
            issues.Notes = comm;
            a.UpdateObject(issues.Id.ToString(), issues);
        }

        public void CreateIss(string idLRPP, string MiniInf, string FullInf, string idRespond)
        {
            var host = "http://testred.ru/";
            var redmine = new RedmineManager(host, infoAuth.loginRm, infoAuth.passwordRm);

            redmine.ImpersonateUser = infoAuth.loginRm;
            User user = redmine.GetCurrentUser();
            IList<IssueCustomField> fields = new List<IssueCustomField>();
            IList<CustomFieldValue> fieldss = new List<CustomFieldValue>();
            IssueCustomField cs = new IssueCustomField();
            CustomFieldValue cf = new CustomFieldValue();

            cf.Info = idLRPP;
            cs.Id = 10;
            fieldss.Add(cf);
            cs.Values = fieldss;
            fields.Add(cs);
            Issue redminetask = new Issue()
            {

                AssignedTo = new IdentifiableName() { Id = Convert.ToInt32(idRespond) },
                Author = new IdentifiableName() { Id = user.Id },
                Subject = MiniInf,
                Description = FullInf,
                Project = new IdentifiableName { Id = 5 },
                StartDate = DateTime.Now,
                CreatedOn = DateTime.Now,                         
                Tracker = new IdentifiableName { Id = 1 },        
                Status = new IdentifiableName { Id = 1 },
                Priority = new IdentifiableName { Id = 1 },
                CustomFields = fields,
                IsPrivate = false,
                Category = new IdentifiableName { Id = 1 },
            };
            redmine.CreateObject(redminetask);
            IdNewIss.id = redminetask.Id;
        }

    }
}
