﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using System.Data.OracleClient;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace RedmineOracle
{
    public class OracleWork
    {
        DbProviderFactory factory;
        DbConnection connection;

        public struct StatusInfo
        {
            public string idStatus { get; set; }
            public string statusName { get; set; }
        }
        public struct FileInfo
        {
            public string id { get; set; }
            public string id_drp { get; set; }
            public string Name { get; set; }
            public string Type { get; set; }
        }
        public struct Users
        {
            public int Id { get; set; }
            public string SystemName { get; set; }
            public string Name { get; set; }
            public string SecondName { get; set; }
            public string LastName { get; set; }
        }
        public struct Comments
        {
            public string Name { get; set; }
            public string Description { get; set; }
            public DateTime Created { get; set; }
            public string Change { get; set; }
            public string SecreteComm { get; set; }
            public string IdDRP { get; set; }
            public string CountFile { get; set; }
        }

        public struct InfoLrp
        {
            public int IdLRP { get; set; }
            public int Priority { get; set; }
            public string MinInfo { get; set; }
            public string Module { get; set; }
            public string Status { get; set; }
            public DateTime TimeStart { get; set; }
            public string LastComment { get; set; }
            public DateTime LastCommentDate { get; set; }
            public string LRPAuthor { get; set; }
            public OracleNumber TimeWorke { get; set; }
            public string Respond { get; set; }
            public string FullInf { get; set; }
            public string CountFileLRP { get; set; }
        }
        OracleConnection oracleConnection;
        public OracleWork()
        {

            factory = DbProviderFactories.GetFactory("System.Data.OracleClient");
            connection = factory.CreateConnection();
            connection.ConnectionString = "Data Source=(DESCRIPTION =(ADDRESS = (PROTOCOL = TCP)(HOST = 192.168.111.197)(PORT = 1521))(CONNECT_DATA = (SERVER = DEDICATED)(SERVICE_NAME = NIS)));Password=dtrnjh340;User ID=ais_disp2";

            oracleConnection = new OracleConnection();
            oracleConnection.ConnectionString = "Data Source=(DESCRIPTION =(ADDRESS = (PROTOCOL = TCP)(HOST = "
                 + "192.168.111.197" + ")(PORT = " + "1521" + "))(CONNECT_DATA = (SERVER = DEDICATED)(SERVICE_NAME = "
                 + "NIS" + ")));Password=" + "dtrnjh340" + ";User ID=" + "ais_disp2";
        }


        public void updateStatus(string idLrp,string currSt,string newSt,string idSt)
        {
            if (oracleConnection.State != ConnectionState.Open)
                oracleConnection.Open();
            string updStatus = "update fault_data set lrp_status_id =" + idSt + " where lrp_id = " + idLrp;
            OracleCommand upd = new OracleCommand(updStatus, oracleConnection);
            upd.ExecuteNonQuery();
            oracleConnection.Close();
            string comm = "Изменение `Статус`: `" + currSt + "`->`" + newSt + "`";
            insertComm(Convert.ToInt32(idLrp),"",comm);
        }

        public List<StatusInfo> getAllStatus(string currSt)
        {
            List<StatusInfo> allSt = new List<StatusInfo>();

            string findCurrSt = "Select lrp_status_id,lrp_status_name from lrp_status where lrp_status_name like '" + currSt + "'";


            string findAllS = "Select lrp_status_id,lrp_status_name from lrp_status where lrp_status_name not like '%Test%' and lrp_status_name not like '" + currSt + "'";
            if (oracleConnection.State != ConnectionState.Open)
                oracleConnection.Open();
            OracleCommand cmdCurrS = new OracleCommand(findCurrSt, oracleConnection);

            OracleDataReader rearCurr = cmdCurrS.ExecuteReader();
            while (rearCurr.Read())
            {
                StatusInfo si = new StatusInfo();
                si.idStatus = rearCurr[0].ToString();
                si.statusName = rearCurr[1].ToString();
                allSt.Add(si);
            }
            OracleCommand oracleCommand = new OracleCommand(findAllS, oracleConnection);

            OracleDataReader reader;
            if (oracleConnection.State != ConnectionState.Open)
            {
                oracleConnection.Open();
                reader = oracleCommand.ExecuteReader();
            }
            else
            {
                reader = oracleCommand.ExecuteReader();
            }
            while (reader.Read())
            {
                StatusInfo si = new StatusInfo();
                si.idStatus = reader[0].ToString();
                si.statusName = reader[1].ToString();
                allSt.Add(si);
            }
            reader.Close();
            oracleConnection.Close();
            return allSt;
        }

        public string FindRmIssue(string idLRP)
        {
            string iss = "Н/З";
            if (oracleConnection.State != ConnectionState.Open)
                oracleConnection.Open();
            string commDon = "select secret_comments from lrp_drp where secret_comments like '%http://testred.ru/issues/%' and lrp_id=" + idLRP;
            OracleCommand cmd = new OracleCommand(commDon, oracleConnection);
            if (cmd.ExecuteScalar() != null)
                iss = cmd.ExecuteScalar().ToString();
            oracleConnection.Close();
            iss = iss.Replace("http://testred.ru/issues/", "");
            return iss;
        }

        public int CheckMaxDrp()
        {
            int max;
            if (oracleConnection.State != ConnectionState.Open)
                oracleConnection.Open();
            string commDon = "select Max(drp_id) from lrp_drp";
            OracleCommand cmd = new OracleCommand(commDon, oracleConnection);
            
            max = Convert.ToInt32(cmd.ExecuteScalar());
            oracleConnection.Close();
            return max;
        }

        public int CheckMaxOpen()
        {
            int max;
            if (oracleConnection.State != ConnectionState.Open)
                oracleConnection.Open();
            string commDon = "select Max(lrp_id) from fault_data where lrp_status_id in(1)";
            OracleCommand cmd = new OracleCommand(commDon, oracleConnection);
            if (oracleConnection.State != ConnectionState.Open)
                oracleConnection.Open();
            max = Convert.ToInt32(cmd.ExecuteScalar());
            oracleConnection.Close();
            return max;
        }

        public int CheckCountOpen()
        {
            int count;
            if (oracleConnection.State == ConnectionState.Closed)
                oracleConnection.Open();
            string commDon = "select Count(lrp_id) from fault_data where lrp_status_id in(1)";
            OracleCommand cmd = new OracleCommand(commDon, oracleConnection);
            if (oracleConnection.State == ConnectionState.Closed)
                oracleConnection.Open();
            count = Convert.ToInt32(cmd.ExecuteScalar());
            oracleConnection.Close();
            return count;
        }

        public List<FileInfo> listFile(string id_drp)
        {
            List<FileInfo> fi = new List<FileInfo>();
            if (oracleConnection.State != ConnectionState.Open)
                oracleConnection.Open();
            string commDon = "select DPR_ID,DRP_BLOB,INF, TYPE_FILE from DRP_FILE where dpr_id =" + id_drp;
            OracleCommand cmd = new OracleCommand(commDon, oracleConnection);
            OracleDataReader reader = cmd.ExecuteReader();
            int i = 0;
            while (reader.Read())
            {
                FileInfo f = new FileInfo();
                f.id_drp = reader[0].ToString();
                f.Name = reader[2].ToString();
                f.Type = reader[3].ToString();
                f.id = i.ToString();
                i++;
                fi.Add(f);
            }
            reader.Close();
            oracleConnection.Close();
            return fi;
        }

        public List<FileInfo> listFileLRP(string id_lrp)
        {
            List<FileInfo> fi = new List<FileInfo>();
            if (oracleConnection.State != ConnectionState.Open)
                oracleConnection.Open();
            string commDon = "select LRP_ID,LRP_BLOB,LRP_INF, TYPE_FILE from lrp_file where lrp_id =" + id_lrp;
            OracleCommand cmd = new OracleCommand(commDon, oracleConnection);
            OracleDataReader reader = cmd.ExecuteReader();
            int i = 0;
            while (reader.Read())
            {
                FileInfo f = new FileInfo();
                f.id_drp = reader[0].ToString();
                f.Name = reader[2].ToString();
                f.Type = reader[3].ToString();
                f.id = i.ToString();
                i++;
                fi.Add(f);
            }
            reader.Close();
            oracleConnection.Close();
            return fi;
        }

        public void TestDonD(string id, string id_file)
        {
            if (oracleConnection.State != ConnectionState.Open)
                oracleConnection.Open();
            FileInfo fileInfo = listFile(id).FirstOrDefault(x => x.id == id_file);
            string commDon = "select DRP_BLOB from DRP_FILE where dpr_id =" + id + " and inf =" + "'" + fileInfo.Name + "'";
            OracleCommand cmd = new OracleCommand(commDon, oracleConnection);
            if (oracleConnection.State != ConnectionState.Open)
                oracleConnection.Open();
            byte[] buffer = (byte[])cmd.ExecuteScalar();
            using (FileStream fs = new FileStream(@"D:\" + fileInfo.Name + "." + fileInfo.Type, FileMode.Create))
            {
                fs.Write(buffer, 0, buffer.Length);
            }
            oracleConnection.Close();
        }

        public void DonLRPFIle(string id, string id_file)
        {
            if (oracleConnection.State != ConnectionState.Open)
                oracleConnection.Open();
            FileInfo fileInfo = listFileLRP(id).FirstOrDefault(x => x.id == id_file);
            string commDon = "select LRP_BLOB from LRP_FILE where lrp_id =" + id + " and lrp_inf =" + "'" + fileInfo.Name + "'";
            OracleCommand cmd = new OracleCommand(commDon, oracleConnection);
            if (oracleConnection.State != ConnectionState.Open)
                oracleConnection.Open();
            byte[] buffer = (byte[])cmd.ExecuteScalar();
            using (FileStream fs = new FileStream(@"D:\" + fileInfo.Name + "." + fileInfo.Type, FileMode.Create))
            {
                fs.Write(buffer, 0, buffer.Length);
            }
            oracleConnection.Close();
        }

        public List<Users> listUsers()
        {
            List<Users> users = new List<Users>();
            string commUsers = "Select t.Firstname ||' '|| t.Secondname ||' '|| t.Lastname as Respond,t.Login,t.USER_ID from spd.T_USERS t ";
            if (oracleConnection.State != ConnectionState.Open)
                oracleConnection.Open();
            OracleCommand comd = new OracleCommand(commUsers, oracleConnection);
            OracleDataReader reader = comd.ExecuteReader();
            while (reader.Read())
            {
                Users user = new Users();
                if (reader[0].ToString() != "")
                    user.Name = reader.GetString(0);
                if (reader[1].ToString() != "")
                    user.SystemName = reader.GetString(1);
                if (reader[2].ToString() != "")
                    user.Id = reader.GetInt32(2);
                users.Add(user);
            }
            oracleConnection.Close();
            return users;
        }

        public async Task<int> chechAuth(string login, string pass)
        {
            int result = -1;
            await Task.Run(() =>
            {
                string commandFindUser = "select t.* from spd.T_USERS t where t.pass='" + pass + "' and t.login ='" + login + "'";
                oracleConnection.Open();
                OracleCommand comd = new OracleCommand(commandFindUser, oracleConnection);
                OracleDataReader reader = comd.ExecuteReader();

                if (reader.HasRows)
                    result = 1;
                else
                    result = -1;
                oracleConnection.Close();

            });
            return result;

        }

        public int findLRP(string id)
        {
            string commandFindLRP = "select t.* from fault_data t where t.lrp_id =" + id.ToString();
            oracleConnection.Open();
            OracleCommand comd = new OracleCommand(commandFindLRP, oracleConnection);
            OracleDataReader reader = comd.ExecuteReader();
            int result;
            if (reader.HasRows)
                result = 1;
            else
                result = -1;
            oracleConnection.Close();
            return result;
        }


        public DataTable outputOpen()
        {
            connection.Open();
            DbCommand command = factory.CreateCommand(); //create a new command
            DbCommand command1 = factory.CreateCommand(); //create a new command
            DataTable dt;
            command.CommandText = "select ft.lrp_id from fault_data ft where lrp_status_id in(1) order by lrp_time_open desc";
            command.Connection = connection; //connect the command
            DbDataAdapter adapter = factory.CreateDataAdapter();//create new adapter
            adapter.SelectCommand = command;
            DataTable dt1;
            DataSet ds = new DataSet(); //create a new dataset
            try
            {
                adapter.Fill(ds, command.CommandText);
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Message);
            }
            dt1 = ds.Tables[0];
            command1.Connection = connection; //connect the command
            DataSet secds = new DataSet(); //create a new dataset

            for (int i = 0; i < dt1.Rows.Count; i++)
            {
                DbDataAdapter adapter1 = factory.CreateDataAdapter();//create new adapter
                string commandCount = "Select Count(drp_change) from lrp_drp where lrp_id = " + dt1.Rows[i].ItemArray[0].ToString();
                OracleCommand command2 = new OracleCommand(commandCount, oracleConnection);
                command1.CommandText = "";
                if (oracleConnection.State != ConnectionState.Open)
                    oracleConnection.Open();
                if (Convert.ToInt32(command2.ExecuteScalar()) > 0)
                {
                    command1.CommandText = "select ft.lrp_id ,ft.lrp_prioritet_id,ft.lrp_mini_inf,lsl.system_name,ls.lrp_status_name,ft.lrp_time_open, t.time_change,t.drp_change, " +
                    "u.Lastname || ' ' || u.Firstname || ' ' || u.Secondname as drp_creator, us.Lastname || ' ' || us.Firstname || ' ' || us.Secondname as respond " +
                    "from fault_data ft, lrp_system_list lsl, lrp_status ls,lrp_drp t, spd.T_Users u, spd.T_Users us " +
                    "where ft.System_Id = lsl.system_id and ft.lrp_status_id = ls.lrp_status_id and ft.lrp_id = t.lrp_id and t.time_change = (select MAX(t.time_change) " +
                    "from lrp_drp t where t.lrp_id = " +
                   dt1.Rows[i].ItemArray[0].ToString() +
                    ") and ft.lrp_id =" +
                  dt1.Rows[i].ItemArray[0].ToString() +
                    "and ft.lrp_opener = u.user_id and ft.lrp_respondent_id = us.user_id";
                }
                else
                {
                    command1.CommandText = "select ft.lrp_id ,ft.lrp_prioritet_id,ft.lrp_mini_inf,lsl.system_name,ls.lrp_status_name,ft.lrp_time_open, " +
                        "u.Lastname || ' ' || u.Firstname || ' ' || u.Secondname as drp_creator, us.Lastname || ' ' || us.Firstname || ' ' || us.Secondname as respond " +
                        "from fault_data ft, lrp_system_list lsl, lrp_status ls, spd.T_Users u, spd.T_Users us " +
                        "where ft.System_Id = lsl.system_id and ft.lrp_status_id = ls.lrp_status_id  and ft.lrp_id = " +
                        dt1.Rows[i].ItemArray[0].ToString() +
                        "and ft.lrp_opener = u.user_id and ft.lrp_respondent_id = us.user_id";
                }

                adapter1.SelectCommand = command1;
                try
                {
                    adapter1.Fill(secds);
                }
                catch (Exception e)
                {
                    MessageBox.Show(e.Message);
                }

            }
            dt = secds.Tables[0]; //copy the table from the dataset to the dataTable
            connection.Close();
            //dt.DefaultView.Sort = "time_change desc";
            return dt;
        }
        public DataTable dtLrp()
        {
            if (connection.State != ConnectionState.Open)
                connection.Open();
            DbCommand command = factory.CreateCommand(); //create a new command
            DbCommand command1 = factory.CreateCommand(); //create a new command
            DataTable dt;
            command.CommandText = "select ft.lrp_id from fault_data ft where lrp_status_id not in(1,3,7)";
            command.Connection = connection; //connect the command
            DbDataAdapter adapter = factory.CreateDataAdapter();//create new adapter
            adapter.SelectCommand = command;
            DataTable dt1;
            DataSet ds = new DataSet(); //create a new dataset
            try
            {
                adapter.Fill(ds, command.CommandText);
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Message);
            }
            dt1 = ds.Tables[0];
            command1.Connection = connection; //connect the command


            DataSet secds = new DataSet(); //create a new dataset
            for (int i = 0; i < dt1.Rows.Count; i++)

            {
                DbDataAdapter adapter1 = factory.CreateDataAdapter();//create new adapter
                command1.CommandText = "select ft.lrp_id ,ft.lrp_prioritet_id,ft.lrp_mini_inf,lsl.system_name,ls.lrp_status_name,ft.lrp_time_open, t.time_change,t.drp_change, " +
                    "u.Lastname || ' ' || u.Firstname || ' ' || u.Secondname as drp_creator, us.Lastname || ' ' || us.Firstname || ' ' || us.Secondname as respond " +
                    "from fault_data ft, lrp_system_list lsl, lrp_status ls,lrp_drp t, spd.T_Users u, spd.T_Users us " +
                    "where ft.System_Id = lsl.system_id and ft.lrp_status_id = ls.lrp_status_id and ft.lrp_id = t.lrp_id and t.time_create = (select MAX(t.time_create) " +
                    "from lrp_drp t where t.lrp_id = " +
                   dt1.Rows[i].ItemArray[0].ToString() +
                    ") and ft.lrp_id =" +
                  dt1.Rows[i].ItemArray[0].ToString() +
                    "and ft.lrp_opener = u.user_id and ft.lrp_respondent_id = us.user_id";
                adapter1.SelectCommand = command1;
                try
                {
                    adapter1.Fill(secds);
                }
                catch (Exception e)
                {
                    MessageBox.Show(e.Message);
                }

            }
            dt = secds.Tables[0]; //copy the table from the dataset to the dataTable
            connection.Close();
            dt.DefaultView.Sort = "time_change desc";
            dt = dt.DefaultView.ToTable();
            return dt;
        }

        public DataTable findRespondLRP(string idUser)
        {
            connection.Open();
            DbCommand command = factory.CreateCommand(); //create a new command
            DbCommand command1 = factory.CreateCommand(); //create a new command
            DataTable dt;
            command.CommandText = "select ft.lrp_id from fault_data ft where lrp_status_id not in(1,3,7) and LRP_RESPONDENT_ID=" + idUser;
            command.Connection = connection; //connect the command
            DbDataAdapter adapter = factory.CreateDataAdapter();//create new adapter
            adapter.SelectCommand = command;
            DataTable dt1;
            DataSet ds = new DataSet(); //create a new dataset
            try
            {
                adapter.Fill(ds, command.CommandText);
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Message);
            }
            dt1 = ds.Tables[0];
            command1.Connection = connection; //connect the command


            DataSet secds = new DataSet(); //create a new dataset
            for (int i = 0; i < dt1.Rows.Count; i++)

            {
                DbDataAdapter adapter1 = factory.CreateDataAdapter();//create new adapter
                command1.CommandText = "select ft.lrp_id ,ft.lrp_prioritet_id,ft.lrp_mini_inf,lsl.system_name,ls.lrp_status_name,ft.lrp_time_open, t.time_change,t.drp_change, " +
                    "u.Lastname || ' ' || u.Firstname || ' ' || u.Secondname as drp_creator, us.Lastname || ' ' || us.Firstname || ' ' || us.Secondname as respond " +
                    "from fault_data ft, lrp_system_list lsl, lrp_status ls,lrp_drp t, spd.T_Users u, spd.T_Users us " +
                    "where ft.System_Id = lsl.system_id and ft.lrp_status_id = ls.lrp_status_id and ft.lrp_id = t.lrp_id and t.time_create = (select MAX(t.time_create) " +
                    "from lrp_drp t where t.lrp_id = " +
                   dt1.Rows[i].ItemArray[0].ToString() +
                    ") and ft.lrp_id =" +
                  dt1.Rows[i].ItemArray[0].ToString() +
                    "and ft.lrp_opener = u.user_id and ft.lrp_respondent_id = us.user_id";
                adapter1.SelectCommand = command1;
                try
                {
                    adapter1.Fill(secds);
                }
                catch (Exception e)
                {
                    MessageBox.Show(e.Message);
                }

            }
            try
            {
                dt = secds.Tables[0];
                connection.Close();
                dt.DefaultView.Sort = "time_change desc";
                dt = dt.DefaultView.ToTable();
                return dt;
            }
            catch { }
            //copy the table from the dataset to the dataTable
            return dtLrp();
        }

        public InfoLrp CurrentLRP(int id)
        {
            InfoLrp currLRP = new InfoLrp();
            string commCurr = commCurr = "select ft.lrp_id,ft.lrp_prioritet_id,ft.lrp_mini_inf,lsl.system_name,ls.lrp_status_name,ft.lrp_time_open, ft.Time_Worke,u.Lastname,u.Firstname,u.Secondname,us.Lastname,us.Firstname,us.Secondname,ft.lrp_inf " +
                "from fault_data ft, lrp_system_list lsl,lrp_status ls,spd.T_Users u, spd.T_Users us " +
                "where ft.System_Id = lsl.system_id and ft.lrp_status_id = ls.lrp_status_id and ft.lrp_id =" + id + "" +
                " and ft.lrp_opener = u.user_id and ft.lrp_respondent_id = us.user_id";
            if (oracleConnection.State != ConnectionState.Open)
                oracleConnection.Open();
            //oracleConnection.Open();
            OracleCommand comd = new OracleCommand(commCurr, oracleConnection);
            OracleDataReader reader = comd.ExecuteReader();
            while (reader.Read())
            {
                currLRP.IdLRP = Convert.ToInt32(reader[0].ToString());
                currLRP.Priority = Convert.ToInt32(reader[1].ToString());
                currLRP.MinInfo = reader[2].ToString();
                currLRP.Module = reader[3].ToString();
                currLRP.Status = reader[4].ToString();
                currLRP.TimeStart = Convert.ToDateTime(reader[5].ToString());
                currLRP.TimeWorke = reader.GetOracleNumber(6);
                currLRP.LRPAuthor = reader[7].ToString() + " " + reader[8].ToString() + " " + reader[9].ToString();
                currLRP.Respond = reader[10].ToString() + " " + reader[11].ToString() + " " + reader[12].ToString();
                currLRP.FullInf = reader[13].ToString();
                string findFileComm = "Select Count(*) from lrp_file where lrp_id = " + id.ToString();
                OracleCommand findCount = new OracleCommand(findFileComm, oracleConnection);
                currLRP.CountFileLRP = findCount.ExecuteScalar().ToString();
            }
            oracleConnection.Close();
            return currLRP;
        }

        public List<Comments> CreateListComm(int id)
        {
            List<Comments> lComm = new List<Comments>();
            string commComment = "select t.comments,t.time_create,t.drp_avtor, t.drp_change, t.secret_comments,t.drp_id from lrp_drp t where t.lrp_id =" + id + " order by t.time_create desc";
            oracleConnection.Open();
            OracleCommand comd = new OracleCommand(commComment, oracleConnection);
            OracleDataReader reader = comd.ExecuteReader();
            while (reader.Read())
            {
                Comments cs = new Comments();
                cs.Description = reader[0].ToString();
                cs.Created = Convert.ToDateTime(reader[1].ToString());
                cs.Name = reader[2].ToString();
                cs.Change = reader[3].ToString();
                cs.SecreteComm = reader[4].ToString();
                cs.IdDRP = reader[5].ToString();
                string FindC = "Select Count(*) from drp_file where dpr_id =" + reader[5].ToString();
                OracleCommand cmFindCount = new OracleCommand(FindC, oracleConnection);
                cs.CountFile = cmFindCount.ExecuteScalar().ToString();
                lComm.Add(cs);
            }
            reader.Close();
            oracleConnection.Close();
            return lComm;
        }

        public string InserCommToRB(int idDRP)
        {
            string comm = "";
            if (oracleConnection.State != ConnectionState.Open)
                oracleConnection.Open();
            string commComment = "Select DRP_AVTOR,DRP_CHANGE,SECRET_COMMENTS from lrp_drp where drp_id =" + idDRP;
            OracleCommand comd = new OracleCommand(commComment, oracleConnection);
            OracleDataReader reader = comd.ExecuteReader();
            while (reader.Read())
            {
                comm = "Автор " + reader[0].ToString() + "\n" + "Комментарий " + reader[1].ToString();
            }
            reader.Close();
            oracleConnection.Close();
            return comm;
        }

        public void insertComm(int id_lrp, string comm_s, string comm)
        {
            oracleConnection.Open();
            string insertComm = "insert into lrp_drp t (t.drp_id, t.lrp_id, t.drp_avtor, t.secret_comments,drp_change,time_change) " +
                "values((select max(drp_id) + 1 from lrp_drp),  " + id_lrp + ", '" + infoAuth.loginForum + "', '" + comm_s + "','" + comm + "',to_date('" + DateTime.Now.ToString("dd.MM.yyyy HH:mm:ss") + "','dd.mm.yyyy HH24:mi:ss'))";
            OracleCommand comd = new OracleCommand(insertComm, oracleConnection);
            comd.ExecuteNonQuery();
            oracleConnection.Close();
        }

    }


}
