﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace RedmineOracle
{
    /// <summary>
    /// Логика взаимодействия для pgIssue.xaml
    /// </summary>
    public partial class pgIssue : Page
    {
        ListIstIssues li;
        OracleWork ow;
        int id;
        bool flag;
        public pgIssue(int id, bool flag)
        {
            InitializeComponent();
            ow = new OracleWork();
            this.flag = flag;
            this.id = id;
            li = new ListIstIssues();
            DataContext = li.currIss(id);
            lbJournal.ItemsSource = li.listNotes(id);
            ListInfo.lbRedmine = lbJournal;

        }


        private void btnSave_Click(object sender, RoutedEventArgs e)
        {
            li.AddNewComm(id, tbNewComm.Text);
            lbJournal.ItemsSource = li.listNotes(id);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            var result = ofd.ShowDialog();
            if (result == true)//если файл выбран
            {
                li.UploadAttachment(id, ofd.FileName);
            }


        }

        private void TextBlock_Loaded(object sender, RoutedEventArgs e)
        {
            TextBlock tb = (TextBlock)sender;
            OracleWork ow = new OracleWork();
            if (!flag)
                if (ow.findLRP(tb.Text) == 1)
                {
                    LoadPages.forumFrame.Navigate(new pgLRP(Convert.ToInt32(tb.Text)));
                }
        }

        private void btnRefresh_Click(object sender, RoutedEventArgs e)
        {
            lbJournal.ItemsSource = li.listNotes(id);
        }

        private void TextBlock_MouseDown(object sender, MouseButtonEventArgs e)
        {
            Clipboard.SetText("http://testred.ru/issues/" + tbIdIss.Text);
            MessageBox.Show("Номер задачи скопирован в буфер обмена!");
        }

        private void btnAddComm_Click(object sender, RoutedEventArgs e)
        {
            Button btn = (Button)sender;
            int idNote = Convert.ToInt32(btn.Uid);
            MessageBoxResult result = MessageBox.Show("Внести изменнения?", "Внесение изменений", MessageBoxButton.YesNo, MessageBoxImage.Information);
            if (result == MessageBoxResult.Yes)
            {
                ListIstIssues.JournaleNotes jn = new ListIstIssues.JournaleNotes();
                jn = li.listNotes(id).FirstOrDefault(x => x.idNote == idNote);
                ow.insertComm(Convert.ToInt32(tbIdLRP.Text), "", jn.NoteDescription);
                ListInfo.lbForum.ItemsSource = ow.CreateListComm(Convert.ToInt32(tbIdLRP.Text));
            }
        }
    }
}
